#!/usr/bin/python3

import networkx as nx
import sys
sys.path.append('/usr/share/botch')
from util import read_graphml, write_graphml, find_node


def descendants(g, source):
    source = find_node(g, source)
    anc = nx.algorithms.descendants(g, source)
    anc.add(source)
    h = g.subgraph(anc)
    return h


def vertex(string):
    try:
        key, value = string.split(":", 1)
    except ValueError:
        raise argparse.ArgumentTypeError(
            "key must be separated from value by a colon")
    return key, value

if __name__ == '__main__':
    import argparse
    parser = argparse.ArgumentParser(
        description="find all descendants of a source vertex in a graph in "
                    "GraphML format")
    parser.add_argument("g", type=read_graphml, nargs='?', default='-',
                        help="Input graph in GraphML format (default: stdin)")
    parser.add_argument("h", type=write_graphml, nargs='?', default='-',
                        help="Output graph in GraphML format "
                        "(default: stdout)")
    parser.add_argument('--source', nargs='+', required=True, type=vertex,
                        help="key:value pairs to match the source vertex")
    parser.add_argument(
        '-v', '--verbose', action='store_true', help='be verbose')
    args = parser.parse_args()
    h = descendants(args.g, args.source)
    args.h(h)
